summaryrefslogtreecommitdiffstats
path: root/src/etc/rc.update_pkg_metadata
diff options
context:
space:
mode:
authorRenato Botelho <renato@netgate.com>2017-08-10 10:09:53 -0300
committerRenato Botelho <renato@netgate.com>2017-08-10 10:09:53 -0300
commite506cc8a3c15852a2776d9dc72695c5b5b2c7134 (patch)
tree3c1b5a9c1a484260200803e2c0f95a25f192443d /src/etc/rc.update_pkg_metadata
parente78d59403b45d7a5b1ea4e4bdfcfbe7a2a65f77a (diff)
downloadpfsense-e506cc8a3c15852a2776d9dc72695c5b5b2c7134.zip
pfsense-e506cc8a3c15852a2776d9dc72695c5b5b2c7134.tar.gz
Make sure pkg metadata is updated at least once daily. It will be used to speedup GUI parts related to pkg update
Diffstat (limited to 'src/etc/rc.update_pkg_metadata')
-rwxr-xr-xsrc/etc/rc.update_pkg_metadata42
1 files changed, 42 insertions, 0 deletions
diff --git a/src/etc/rc.update_pkg_metadata b/src/etc/rc.update_pkg_metadata
new file mode 100755
index 0000000..8c4e019
--- /dev/null
+++ b/src/etc/rc.update_pkg_metadata
@@ -0,0 +1,42 @@
+#!/bin/sh
+#
+# rc.update_pkg_metadata
+#
+# Copyright (c) 2017 Rubicon Communications, LLC (Netgate). All rights reserved.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+if [ "$1" = "now" ]; then
+ sleep_time=0
+else
+ sleep_time=$(jot -r 1 1 86399)
+fi
+
+# Read product_name from $g, defaults to pfSense
+product=$(/usr/local/sbin/read_global_var product_name pfSense)
+
+tmp_version=$(mktemp -q /tmp/${product}_version.XXXXXXXX) \
+ || exit 1
+
+( \
+ sleep $sleep_time \
+ && /usr/local/sbin/${product}-upgrade -uf \
+ && ( \
+ /usr/local/sbin/${product}-upgrade -Uc >> $tmp_version \
+ ; test $? -eq 2 && return 0 \
+ ) \
+ && mv $tmp_version /var/run/${product}_version \
+ || rm -f $tmp_version
+) >/dev/null 2>&1 &
+
+exit 0
OpenPOWER on IntegriCloud